%define qt4_bindir %{_libdir}/qt4/bin
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name: qgis
Version: 0.11.0
Release: 6%{?dist}
Summary: A user friendly Open Source Geographic Information System

Group: Applications/Engineering
License: GPLv2+
URL: http://qgis.org/
Source0: http://download.osgeo.org/qgis/src/%{name}_%{version}.tar.gz
Source1: %{name}.desktop
# https://trac.osgeo.org/qgis/changeset/9629
Patch0: qgis-0.11-pyqt-sip-typedef.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake
BuildRequires: desktop-file-utils
BuildRequires: qt4-devel
BuildRequires: bison, flex
BuildRequires: expat-devel
BuildRequires: gdal-devel
BuildRequires: geos-devel
BuildRequires: gsl-devel
BuildRequires: postgresql-devel
BuildRequires: sqlite-devel
# grass package contains definitions needed for configure script
BuildRequires: grass, grass-devel
BuildRequires: python-devel
BuildRequires: PyQt4-devel
BuildRequires: chrpath
# fixing missing library calls in atlas
BuildRequires: blas, lapack

%description
Quantum GIS (QGIS) is a user friendly Open Source Geographic Information 
System (GIS) that runs on Linux, Unix, Mac OSX, and Windows. QGIS supports 
vector, raster, and database formats. QGIS is licensed under the GNU 
General Public License. QGIS lets you browse and create map data on your 
computer. It supports many common spatial data formats (e.g. ESRI ShapeFile, 
geotiff). QGIS supports plugins to do things like display tracks from your GPS.


%package devel
Summary: Headers and libraries for building against qgis
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
Headers and libraries for building against qgis


%package grass
Summary: GRASS plugins for qgis
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Requires: grass

%description grass
GRASS plugins for qgis


%package python
Summary: Python integration and plugins for qgis
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Requires: sip
Requires: PyQt4

%description python
Python integration and plugins for qgis


%package theme-nkids
Summary: Addtional theme for qgis - nkids
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}

%description theme-nkids
Addtional theme for qgis - nkids


%prep
%setup -q -n %{name}_%{version}
%patch0 -p2

# fix spurious executable bits
%{__chmod} -x \
	./src/app/legend/qgslegend.h \
	./src/app/legend/qgslegend.cpp \
	./src/gui/qgsdetaileditem*.cpp \
	./src/gui/qgsdetaileditem*.h


%build
for dir in %{_libdir}/grass-*/ ; do
	GRASS_PREFIX=$dir
done
%cmake \
	-D QGIS_MANUAL_SUBDIR=share/man \
	-D QGIS_LIB_SUBDIR=%{_lib} \
	-D QGIS_PLUGIN_SUBDIR=%{_lib}/qgis \
	-D BINDINGS_GLOBAL_INSTALL:BOOL=ON \
	-D GRASS_PREFIX=$GRASS_PREFIX \
	-D GDAL_INCLUDE_DIR=%{_includedir}/gdal \
	-D GDAL_LIBRARY=%{_libdir}/libgdal.so \
	.
make VERBOSE=1 %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot}
make VERBOSE=1 DESTDIR=%{buildroot} install

# remove rpath from files
chrpath --delete \
	%{buildroot}%{_bindir}/%{name} \
	%{buildroot}%{python_sitearch}/%{name}/*.so

# add executable perms to python libs so they get striped
%{__chmod} +x %{buildroot}%{python_sitearch}/%{name}/*.so

# remove files packaged by doc
%{__rm} -f %{buildroot}%{_datadir}/doc/AUTHORS \
	%{buildroot}%{_datadir}/doc/SPONSORS

# install desktop file
%{__install} -d %{buildroot}%{_datadir}/pixmaps
%{__install} -m0644 \
	%{buildroot}%{_datadir}/%{name}/images/icons/qgis-icon.png \
	%{buildroot}%{_datadir}/pixmaps/%{name}.png
desktop-file-install --vendor="fedora" \
	--dir=%{buildroot}%{_datadir}/applications \
	%{SOURCE1}


%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post grass -p /sbin/ldconfig

%postun grass -p /sbin/ldconfig

%post python -p /sbin/ldconfig

%postun python -p /sbin/ldconfig


%files
%defattr(-, root, root, -)
%doc AUTHORS BUGS COPYING ChangeLog README SPONSORS CONTRIBUTORS
%{_bindir}/%{name}
%{_bindir}/%{name}_help
%{_libdir}/lib%{name}_*.so.*
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/libcopyrightlabelplugin.so
%{_libdir}/%{name}/libdelimitedtextplugin.so
%{_libdir}/%{name}/libdelimitedtextprovider.so
%{_libdir}/%{name}/libgeorefplugin.so
%{_libdir}/%{name}/libgpsimporterplugin.so
%{_libdir}/%{name}/libgpxprovider.so
%{_libdir}/%{name}/libgridmakerplugin.so
%{_libdir}/%{name}/libmemoryprovider.so
%{_libdir}/%{name}/libnortharrowplugin.so
%{_libdir}/%{name}/libogrprovider.so
%{_libdir}/%{name}/libpggeoprocessingplugin.so
%{_libdir}/%{name}/libpostgresprovider.so
%{_libdir}/%{name}/libquickprintplugin.so
%{_libdir}/%{name}/libscalebarplugin.so
%{_libdir}/%{name}/libspitplugin.so
%{_libdir}/%{name}/libwfsplugin.so
%{_libdir}/%{name}/libwfsprovider.so
%{_libdir}/%{name}/libwmsprovider.so
%{_datadir}/%{name}/doc
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/applications/fedora-%{name}.desktop
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/i18n
%{_datadir}/%{name}/images
%{_datadir}/%{name}/resources
%{_datadir}/%{name}/svg
%dir %{_datadir}/%{name}/themes
%dir %{_datadir}/%{name}/themes/default
%{_datadir}/%{name}/themes/default/*.png
%{_mandir}/man1/*

%files devel
%defattr(-, root, root, -)
%{_includedir}/%{name}
%{_libdir}/lib%{name}_*.so
%{_libdir}/libqgisgrass.so
%{_libdir}/libqgispython.so

%files grass
%defattr(-, root, root, -)
%{_libdir}/libqgisgrass.so.*
%{_libdir}/%{name}/libgrass*.so
%{_datadir}/%{name}/grass
%{_datadir}/%{name}/themes/default/grass

%files python
%defattr(-, root, root, -)
%{_libdir}/libqgispython.so.*
%{_datadir}/%{name}/python
%{python_sitearch}/%{name}

%files theme-nkids
%defattr(-, root, root, -)
%{_datadir}/%{name}/themes/nkids


%changelog
* Thu Dec 18 2008 Douglas E. Warner <silfreed@silfreed.net> - 0.11.0-6
- adding patch to fix typedef problems in python build

* Thu Dec 18 2008 Douglas E. Warner <silfreed@silfreed.net> - 0.11.0-5
- Rebuild for Python 2.6

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.11.0-4
- Rebuild for Python 2.6

* Sun Oct 19 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 0.11.0-3
- Rebuild for new geos, fixes broken deps

* Mon Aug 11 2008 Douglas E. Warner <silfreed@silfreed.net> 0.11.0-2
- building against blas and lapack instead of atlas and blas to fix missing
  library calls

* Wed Jul 16 2008 Douglas E. Warner <silfreed@silfreed.net> 0.11.0-1
- update to metis 0.11.0
- remove python patch
- enabling python subpackage
- fixed executable perms on new headers/source
- stripping rpath with chrpath
- making python libs executable to get files stripped

* Fri Mar 28 2008 Douglas E. Warner <silfreed@silfreed.net> 0.10.0-2
- added patch to support cmake 2.6

* Fri Mar 28 2008 Balint Cristian <rezso@rdsor.ro> - 0.10.0-1
- upgraded to 0.10.0 release candidate
- removed gcc 4.3 patches
- adding devel package since libraries are now versioned

* Fri Mar 28 2008 Balint Cristian <rezso@rdsor.ro> - 0.9.1-5
- fix build by adding more gcc43 patches
- rebuild against grass63

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.1-4
- Autorebuild for GCC 4.3

* Mon Feb 18 2008 Douglas E. Warner <silfreed@silfreed.net> 0.9.1-4
- adding gcc43-INT_MAX-qgis-0.9.1.patch
- adding gcc43-duplicate_function_param-qgis-0.9.1.patch
- adding gcc43-memcpy-qgis-0.9.1.patch
- adding gcc43-memcpy-strtod-qgis-0.9.1.patch

* Mon Feb 18 2008 Douglas E. Warner <silfreed@silfreed.net> 0.9.1-3
- adding Requires sip, PyQt4 for python bindings support

* Mon Jan 28 2008 Douglas E. Warner <silfreed@silfreed.net> 0.9.1-2
- defining lib path in build
- installing python bindings globally
- adding patch to determine python site packages dir correctly

* Mon Dec 17 2007 Douglas E. Warner <silfreed@silfreed.net> 0.9.1-1
- update to 0.9.1
- removing lib64 and man instal path patches (included upstream)
- enabling python integration

* Fri Oct 05 2007 Douglas E. Warner <silfreed@silfreed.net> 0.9.0-2
- enabling build for PPC64 (bug#247152)

* Wed Sep 26 2007 Douglas E. Warner <silfreed@silfreed.net> 0.9.0-1
- update to 0.9.0
- remove settings-include-workdir.patch
- updated man-install-share.patch to man-install-share-0.9.0.patch
- updated lib64-suffix.patch to lib64-suffix-0.9.0.patch
- enabled python to support msexport tool
- added Requires: grass to grass subpackage

* Tue Aug 28 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-13
- bump for expat 2.0 rebuild bug#195888

* Thu Aug 02 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-12
- updated License from GPL to GPLv2+

* Tue Jul 10 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-11
- allowing docs to be installed by qgis so they can be referenced by internal
  help system (bug#241403)
- updated lib64 patch (bug#247549) to try to get plugins found on x86_64

* Thu Jul 05 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-10
- updated lib64 patch for core and grass libraries

* Thu Jul 05 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-9
- updated lib64 patch

* Thu Jul 05 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-8
- adding ExcludeArch: ppc64 for bug#247152 (lrelease segfault)

* Thu Jul 05 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-7
- adding patch for lib64 support through lib_suffix

* Thu Jun 28 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-6
- fixed date of changelog entry for 0.8.1-5 from Wed Jun 27 2007 to
  Thu Jun 28 2007
- linking icon to included png instead of packaging it again

* Thu Jun 28 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-5
- adding comment on why grass is required in addition to grass-devel for BR
- fixing typo

* Wed Jun 27 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-4
- adding contributors to doc
- adding desktop file and icon

* Mon Jun 25 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-3
- updating detection of grass libraries to not use RPM call
- disabling building of -devel package due to shared libraries not being 
  versioned and having no other packages that compile against qgis
  (see bug #241403)
- removing chmod of test_export.py due to lack of python requirement
- removing msexport and share/python directory due to removal of python

* Fri Jun 22 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-2
- added BuildRequires: cmake
- updated build to use cmake macro and make verbose

* Mon Jun 19 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.1-1
- updating version
- removed BuildRequires: python-devel due to lack of PyQt4 bindings
- updated build for use of cmake instead of autotools
- added patch for setting WORKDIR in settings.pro file
- added patch for fixing install path of man pages
- updated library names

* Tue May 29 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-6
- adding BuildRequires bison, flex

* Tue May 29 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-5
- fixing more directory owernship (themes, themes-default)
- fixing qt4 hardcoded lib path
- removing Requires ldconfig
- adding BuildRequires sqlite-devel
- adding patch for supporting python 2.5 in configure script

* Sat May 26 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-4
- moving all BuildRequires to main section
- dropping use of makeinstall macro
- making sure directories are owned by this package
- removing *.a and *.la files
- disabled stripping of libraries and binaries to allow debuginfo package
  to be built
- fixing macros in changelog
- removing executable bits on source files

* Wed May 16 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-3
- fixing Requires statements for sub-packages

* Tue May 15 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-2
- added devel dependancy on qgis
- moved qgis-config to devel package
- moving doc directory
- removed zero-length NEWS doc
- added postin/postun ldconfig calls
- split packages up to reduce package size and split out dependancies
  grass, theme-nkids

* Mon May 14 2007 Douglas E. Warner <silfreed@silfreed.net> 0.8.0-1
- Initial RPM release.
